
# Exemplu simplu de utilizare a metodei kmeans

data(iris)

# se exclude atributul de clasa (gruparea se bazeaza pe un proces de invatare neesupervizata)
irisClust <- iris[,-5]

# se aplica algoritmul de grupare pentru cazul a 3 clase
resKmeans <- kmeans(irisClust,centers=3)

# vizualizarea rezultatului gruparii obtinute prin kMeans
plot(irisClust, col = resKmeans$cluster)
points(resKmeans$centers, col = 4, pch = 5, cex = 2)

# vizualizarea gruparii reale
dev.new()
plot(iris[,-5], col = as.numeric(iris[,5]))

# Determinarea numarului adecvat de clustere:  cel caruia ii corespunde cea mai mica valoare a variantei intra-cluster 
wss <- (nrow(irisClust)-1)*sum(apply(irisClust,2,var))  # calcul suma patratelor abaterilor fata de medie

# analiza cazurilor in care numarul de clustere variaza intre 2 si 20
for (i in 2:20) wss[i] <- sum(kmeans(irisClust,centers=i)$withinss)
plot(1:20, wss, type="b", xlab="Number of Clusters",ylab="Within groups sum of squares") 

bss <- 1:19 # creare vector pentru stocare varianta inter-cluster
for (i in 2:20) bss[i] <- sum(kmeans(irisClust,centers=i)$betweenss)
plot(1:20, bss, type="b", xlab="Number of Clusters",ylab="Between groups sum of squares") 


# ??? Lab/Tema:  analizati valorile raportului intra-cluster Variance/inter-cluster Variance 

# Indicatie
r <- 1:19
for (i in 2:20) r[i] <- wss[i]/bss[i]
plot(1:20, r, type="b", xlab="Number of Clusters",ylab="Ratio")

# ??? Lab/Tema:  utilizati Silhouette pt a stabili numarul adecvat de clustere

# Indicatie - se foloseste fctia silhouette din pachetul cluster
library(cluster)
ss <- silhouette(resKmeans$cluster, dist(irisClust))

# TODO:  se calculeaza media valorilor sil_width din ss;  se repeta pentru valorile lui k (ca in cazul de mai sus)

# Limite ale algoritmului kMeans - exemplu de set de date pentru care kMeans nu functioneaza bine

library("dbscan")
data(DS3)
plot(DS3)
dev.new()
resDS3 <- kmeans(DS3,centers=6)
plot(DS3, col = resDS3$cluster)



dist(irisClust)
