# Exemplu utilizare DBSCAN - identificarea clusterelor cu forme arbitrare
library("dbscan")

# data bidimensionale - clustere geometrice
data("DS3")
plot(DS3)

# estimarea unei valori pt parametrul epsilon search folosind distantele dintre cei mai apropiati vecini
kNNdistplot(DS3, k = 5)
abline(h=6, col = "red", lty=2)

# aplicare DBSCAN 
res <- dbscan(DS3, eps = 5.5, minPts = 5)
res

# vizualizare clustere (puncte nucleu (core points) si puncte frontiere (border points))
plot(DS3, col=res$cluster)

# vizualizarea zgomotului/ elementelor atipice (noisy points) - punctele cu eticheta 0
points(DS3[res$cluster==0,], pch = 3, col = "grey")

### ?? Lab: calculati indicele Silhouette pt partitiile obtinute utilizand diferite valori ale parametrilor 
###     eps si minPts 